#! /usr/bin/env node
"use strict";
/* c8 ignore start */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
const list_files_js_1 = require("../modules/list-files.js");
const get_arg_js_1 = require("../helpers/get-arg.js");
const index_js_1 = require("../index.js");
const get_runtime_js_1 = require("../helpers/get-runtime.js");
const format_js_1 = require("../helpers/format.js");
// Argument with values
const dirs = ((0, get_arg_js_1.hasArg)('include')
    ? (_a = (0, get_arg_js_1.getArg)('include')) === null || _a === void 0 ? void 0 : _a.split(',')
    : (_b = (0, get_arg_js_1.getLastParam)()) === null || _b === void 0 ? void 0 : _b.split(',')) || [];
const platform = (0, get_arg_js_1.getArg)('platform');
const filter = (0, get_arg_js_1.getArg)('filter');
const exclude = (0, get_arg_js_1.getArg)('exclude');
const killPort = (0, get_arg_js_1.getArg)('kill-port');
const killRange = (0, get_arg_js_1.getArg)('kill-range');
const killPID = (0, get_arg_js_1.getArg)('kill-pid');
const concurrency = Number((0, get_arg_js_1.getArg)('concurrency')) || undefined;
const denoAllow = (0, get_arg_js_1.getSubArg)('deno-allow');
const denoDeny = (0, get_arg_js_1.getSubArg)('deno-deny');
// Multiple arguments with values or not
// TODO (Custom Args)
// const args = getAllArgs('arg');
// Argument exists
const parallel = (0, get_arg_js_1.hasArg)('parallel');
const quiet = (0, get_arg_js_1.hasArg)('quiet');
const debug = (0, get_arg_js_1.hasArg)('debug');
const failFast = (0, get_arg_js_1.hasArg)('fail-fast');
if ((0, get_arg_js_1.hasArg)('log-success'))
    console.log(`The flag ${format_js_1.format.bold('--log-success')} is deprecated. Use ${format_js_1.format.bold('--debug')} instead.`);
(() => __awaiter(void 0, void 0, void 0, function* () {
    if (killPort) {
        const ports = killPort.split(',').map((port) => Number(port));
        yield index_js_1.kill.port(ports);
    }
    if (killRange) {
        const ranges = killRange.split(',');
        for (const range of ranges) {
            const ports = range.split('-').map((port) => Number(port));
            const startsAt = ports[0];
            const endsAt = ports[1];
            yield index_js_1.kill.range(startsAt, endsAt);
        }
    }
    if (killPID) {
        const PIDs = killPID.split(',').map((port) => Number(port));
        yield index_js_1.kill.pid(PIDs);
    }
    yield (0, index_js_1.poku)(dirs, {
        platform: (0, get_runtime_js_1.platformIsValid)(platform) ? platform : undefined,
        filter: filter ? new RegExp((0, list_files_js_1.escapeRegExp)(filter)) : undefined,
        exclude: exclude ? new RegExp((0, list_files_js_1.escapeRegExp)(exclude)) : undefined,
        parallel,
        quiet,
        debug,
        failFast,
        concurrency,
        // TODO (Custom Args)
        // arguments: args.length > 0 ? args : undefined,
        deno: {
            allow: denoAllow,
            deny: denoDeny,
        },
    });
}))();
/* c8 ignore stop */
