/// <reference types="node" />
import * as nodeAssert from 'node:assert';
import { ParseAssertionOptions } from '../@types/assert.js';
declare function doesNotThrow(block: () => unknown, message?: string | ParseAssertionOptions['message']): Promise<void>;
declare function doesNotThrow(block: () => unknown, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): Promise<void>;
declare function throws(block: () => unknown, message?: ParseAssertionOptions['message']): Promise<void>;
declare function throws(block: () => unknown, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): Promise<void>;
declare function rejects(block: (() => Promise<unknown>) | Promise<unknown>, message?: string | Error): Promise<void>;
declare function rejects(block: (() => Promise<unknown>) | Promise<unknown>, error: nodeAssert.AssertPredicate, message?: string | Error): Promise<void>;
declare function doesNotReject(block: (() => Promise<unknown>) | Promise<unknown>, message?: string | Error): Promise<void>;
declare function doesNotReject(block: (() => Promise<unknown>) | Promise<unknown>, error: nodeAssert.AssertPredicate, message?: string | Error): Promise<void>;
export declare const assertPromise: ((value: unknown, message?: ParseAssertionOptions['message']) => Promise<void>) & {
    ok: (value: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    equal: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    deepEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    strictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    deepStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    doesNotMatch: (value: string, regExp: RegExp, message?: ParseAssertionOptions['message']) => Promise<void>;
    doesNotReject: typeof doesNotReject;
    throws: typeof throws;
    doesNotThrow: typeof doesNotThrow;
    notEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    notDeepEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    notStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    notDeepStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    match: (value: string, regExp: RegExp, message?: ParseAssertionOptions['message']) => Promise<void>;
    ifError: (value: unknown, message?: ParseAssertionOptions['message']) => Promise<void>;
    fail: (message?: ParseAssertionOptions['message']) => Promise<void>;
    rejects: typeof rejects;
};
export {};
